#pragma once


#include <winsock2.h>
#include <vector>
#include "MediaDecoder.h"


class CTsNetworkSender : public CMediaDecoder
{
public:
	CTsNetworkSender(IEventHandler *pEventHandler = NULL);
	virtual ~CTsNetworkSender();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CTsNetwokSender
	enum SocketType {
		SOCKET_UDP,
		SOCKET_TCP
	};
	struct AddressInfo {
		SocketType Type;
		const char *pszAddress;
		WORD Port;
	};
	const bool Open(const AddressInfo *pList, DWORD Length);
	const bool Close();
	const bool IsOpen() const;

	const bool SetSendSize(DWORD Size);
	const DWORD GetSendSize() const;
	const bool SetSendWait(DWORD Wait);
	const DWORD GetSendWait() const;
	const bool SetAdjustWait(bool bAdjust);
	const bool GetAdjustWait() const;

protected:
	const bool GetStream(BYTE **ppBuffer,SIZE_T *pBufferLength);
	static DWORD WINAPI SendThread(LPVOID lpParameter);

	HANDLE m_hSendThread;
	//HANDLE m_hKillEvent;
	volatile bool m_bKillSignal;
	DWORD m_SendSize;
	DWORD m_SendWait;
	bool m_bAdjustWait;

	bool m_bEnableBuffering;
	DWORD m_BufferLength;
	BYTE *m_pBuffer;
	DWORD m_BufferUsed;
	DWORD m_BufferPos;

	struct SocketInfo {
		SocketType Type;
		SOCKET sock;
		struct sockaddr_in addr;
		bool bConnected;
		WSAEVENT Event;
	};
	std::vector<SocketInfo> m_SockList;
};
