#pragma once


#include <winsock2.h>
#include <vector>
#include "MediaDecoder.h"


class CTsUdpSender : public CMediaDecoder
{
public:
	CTsUdpSender(IEventHandler *pEventHandler = NULL);
	virtual ~CTsUdpSender();

// IMediaDecoder
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CTsUdpSender
	struct AddressInfo {
		const char *pszAddress;
		WORD Port;
	};
	const bool Open(const AddressInfo *pList, DWORD Length);
	const bool Close();
	const bool IsOpen() const;

	const bool SetSendSize(DWORD Size);
	const DWORD GetSendSize() const;
	const bool SetSendWait(DWORD Wait);
	const DWORD GetSendWait() const;

protected:
	const bool GetStream(BYTE **ppBuffer,SIZE_T *pBufferLength);
	static DWORD WINAPI SendThread(LPVOID lpParameter);

	HANDLE m_hSendThread;
	//HANDLE m_hKillEvent;
	volatile bool m_bKillSignal;
	DWORD m_SendSize;
	DWORD m_SendWait;

	DWORD m_BufferLength;
	BYTE *m_pBuffer;
	DWORD m_BufferUsed;
	DWORD m_BufferPos;

	struct SocketInfo {
		SOCKET sock;
		struct sockaddr_in addr;
	};
	std::vector<SocketInfo> m_SockList;
};
