#include "StdAfx.h"
#include "BonSrcFilter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif




CBonSrcFilter::CBonSrcFilter(LPUNKNOWN pUnk, HRESULT *phr)
	: CBaseFilter(TEXT("Bon Source Filter"), pUnk, &m_cStateLock, CLSID_BONSOURCE)
	, m_pSrcPin(NULL)
	, m_bOutputWhenPaused(false)
{
	TRACE(TEXT("CBonSrcFilter::CBonSrcFilter %p\n"),this);

	// s̃CX^X
	m_pSrcPin = new CBonSrcPin(phr, this);

	//*phr = (m_pSrcPin)? S_OK : E_OUTOFMEMORY;
	*phr=S_OK;
}

CBonSrcFilter::~CBonSrcFilter()
{
	// s̃CX^X폜
	if(m_pSrcPin)delete m_pSrcPin;
}

IBaseFilter* WINAPI CBonSrcFilter::CreateInstance(LPUNKNOWN pUnk, HRESULT *phr,CBonSrcFilter **ppBonSrcFilterIf)
{
	// CX^X쐬
	if(ppBonSrcFilterIf) *ppBonSrcFilterIf = NULL;
	CBonSrcFilter *pNewFilter = new CBonSrcFilter(pUnk, phr);
	/*
	if(!pNewFilter){
		*phr = E_OUTOFMEMORY;
		return NULL;
	}
	*/

	IBaseFilter *pFilter;
	*phr=pNewFilter->QueryInterface(IID_IBaseFilter,(void**)&pFilter);
	if (FAILED(*phr)) {
		delete pNewFilter;
		return NULL;
	}
	if(ppBonSrcFilterIf) *ppBonSrcFilterIf = pNewFilter;
	return pFilter;
}


int CBonSrcFilter::GetPinCount(void)
{
	// sԂ
	return 1;
}


CBasePin * CBonSrcFilter::GetPin(int n)
{
	// s̃CX^XԂ
	return (n == 0)? m_pSrcPin : NULL;
}


#ifdef _DEBUG

STDMETHODIMP CBonSrcFilter::Run(REFERENCE_TIME tStart)
{
	TRACE(L"CBonSrcFilter::Run()\n");

	return CBaseFilter::Run(tStart);
}


STDMETHODIMP CBonSrcFilter::Pause(void)
{
	TRACE(L"CBonSrcFilter::Pause()\n");

	return CBaseFilter::Pause();
}


STDMETHODIMP CBonSrcFilter::Stop(void)
{
	TRACE(L"CBonSrcFilter::Stop()\n");

	return CBaseFilter::Stop();
}

#endif


STDMETHODIMP CBonSrcFilter::GetState(DWORD dw, FILTER_STATE *pState)
{
	*pState = m_State;
	if (m_State==State_Paused && !m_bOutputWhenPaused)
		return VFW_S_CANT_CUE;
	return S_OK;
}


const bool CBonSrcFilter::InputMedia(CMediaData *pMediaData)
{
	m_cStateLock.Lock();
	if (!m_pSrcPin
			|| m_State==State_Stopped
			|| (m_State==State_Paused && !m_bOutputWhenPaused)) {
		m_cStateLock.Unlock();
		return false;
	}
	m_cStateLock.Unlock();
	return m_pSrcPin->InputMedia(pMediaData);
}


void CBonSrcFilter::Reset()
{
	if (m_pSrcPin)
		m_pSrcPin->Reset();
}


void CBonSrcFilter::Flush()
{
	CAutoLock Lock(m_pLock);

	if (m_pSrcPin)
		m_pSrcPin->Flush();
}


void CBonSrcFilter::SetOutputWhenPaused(bool bOutput)
{
	m_bOutputWhenPaused=bOutput;
	if (m_pSrcPin)
		m_pSrcPin->SetOutputWhenPaused(bOutput);
}


/*
// ̏ꂵ̂̊֐
bool CBonSrcFilter::CheckHangUp(DWORD TimeOut)
{
	// ׈ȃLXg
	CRITICAL_SECTION *pCritSec=(CRITICAL_SECTION*)&m_cStateLock;
	DWORD i;

	for (i=TimeOut;i>0;i--) {
		if (::TryEnterCriticalSection(pCritSec))
			break;
		Sleep(1);
	}
	if (i==0) {
		TRACE(TEXT("Filter graph is hang up.\n"));
		return true;
	}
	::LeaveCriticalSection(pCritSec);
	return false;
}
*/
