// DtvEngine.cpp: CDtvEngine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DtvEngine.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define SID_INVALID 0xFFFF


//////////////////////////////////////////////////////////////////////
// CDtvEngine \z/
//////////////////////////////////////////////////////////////////////

CDtvEngine::CDtvEngine(void)
	: m_pDtvEngineHandler(NULL)
	, m_wCurTransportStream(0U)
	, m_wCurService(0xFFFF)
	, m_CurServiceID(SID_INVALID)
	, m_SpecServiceID(SID_INVALID)
	, m_b1SegService(false)
	, m_u64CurPcrTimeStamp(0UL)
	, m_BonSrcDecoder(this)
	, m_TsPacketParser(this)
	, m_TsAnalyzer(this)
	, m_TsDescrambler(this)
	, m_ProgManager(this)
	, m_MediaTee(this)
	, m_FileWriter(this)
	, m_MediaGrabber(this)
	, m_TvRockGrabber(this)
	, m_FileTsSelector(this)
	, m_NetworkTsSelector(this)
	, m_TsNetworkSender(this)
	, m_bBuiled(false)
	, m_bBuildComplete(false)
	, m_bDescramble(true)
	, m_bDescrambleCurServiceOnly(false)
	, m_bWriteCurServiceOnly(false)
	, m_WriteStream(CTsSelector::STREAM_ALL)
	, m_bSendCurServiceOnly(false)
	, m_SendStream(CTsSelector::STREAM_ALL)
{
}


CDtvEngine::~CDtvEngine(void)
{
	CloseEngine();
}


const bool CDtvEngine::BuildEngine(CDtvEngineHandler *pDtvEngineHandler,bool bDescramble)
{
	// SɎb
	if (m_bBuiled)
		return true;

	/*
	Ot\}

	m_BonSrcDecoder
		
	m_TsPacketParser
		
	m_TsAnalyzer
		
	m_TsDescrambler
		
	m_ProgManager	// 폜\(CTsAnalyzerɒu)
		
	m_MediaGrabber
		
	m_MediaTee
		                
	m_TvRockGrabber   m_NetworkTsSelector
		                
	m_FileTsSelector  m_TsNetworkSender
		
	m_FileWriter
	*/

	Trace(TEXT("fR[_Ot\zĂ܂..."));

	// fR[_Ot\z
	m_TsPacketParser.SetOutputDecoder(&m_TsAnalyzer);
	m_TsAnalyzer.SetOutputDecoder(&m_TsDescrambler);
	m_TsDescrambler.SetOutputDecoder(&m_ProgManager);
	m_TsDescrambler.EnableDescramble(bDescramble);
	m_bDescramble=bDescramble;
	m_ProgManager.SetOutputDecoder(&m_MediaGrabber);
	m_MediaGrabber.SetOutputDecoder(&m_MediaTee);
	m_MediaTee.SetOutputDecoder(&m_TvRockGrabber, 0);
	m_MediaTee.SetOutputDecoder(&m_NetworkTsSelector, 1);
	m_TvRockGrabber.SetOutputDecoder(&m_FileTsSelector);
	m_FileTsSelector.SetOutputDecoder(&m_FileWriter);
	m_NetworkTsSelector.SetOutputDecoder(&m_TsNetworkSender);

	// Cxgnhݒ
	m_pDtvEngineHandler = pDtvEngineHandler;

	m_bBuiled=true;
	m_bBuildComplete=CheckBuildComplete();

	return true;
}


const bool CDtvEngine::CloseEngine(void)
{
	//if (!m_bBuiled)
	//	return true;

	Trace(TEXT("DtvEngineĂ܂..."));

	ReleaseSrcFilter();

	Trace(TEXT("J[h[_Ă܂..."));
	m_TsDescrambler.CloseBcasCard();

	// Cxgnh
	m_pDtvEngineHandler = NULL;

	m_bBuiled=false;

	Trace(TEXT("DtvEngine܂B"));

	return true;
}


const bool CDtvEngine::ResetEngine(void)
{
	if (!m_bBuiled)
		return false;

	// fR[_OtZbg
	ResetStatus();
	m_BonSrcDecoder.ResetGraph();

	return true;
}


const bool CDtvEngine::OpenSrcFilter_BonDriver(HMODULE hBonDriverDll)
{
	ReleaseSrcFilter();
	// \[XtB^J
	Trace(TEXT("`[iJĂ܂..."));
	if (!m_BonSrcDecoder.OpenTuner(hBonDriverDll)) {
		SetError(m_BonSrcDecoder.GetLastErrorException());
		m_bBuildComplete=false;
		return false;
	}
	Trace(TEXT("Xg[̍ĐJnĂ܂..."));
	if (!m_BonSrcDecoder.Play()) {
		SetError(m_BonSrcDecoder.GetLastErrorException());
		m_bBuildComplete=false;
		return false;
	}
	m_BonSrcDecoder.SetOutputDecoder(&m_TsPacketParser);
	//ResetEngine();
	ResetStatus();

	m_bBuildComplete=CheckBuildComplete();

	return true;
}


const bool CDtvEngine::ReleaseSrcFilter()
{
	// \[XtB^J
	if (m_BonSrcDecoder.IsOpen()) {
		m_BonSrcDecoder.CloseTuner();
		m_BonSrcDecoder.SetOutputDecoder(NULL);
	}
	return true;
}


const bool CDtvEngine::IsSrcFilterOpen() const
{
	return m_BonSrcDecoder.IsOpen();
}


const BYTE CDtvEngine::GetAudioComponentType()
{
	//return m_ProgManager.GetAudioComponentType(m_CurAudioStream, m_wCurService);
	return m_ProgManager.GetAudioComponentType(0, m_wCurService);
}


const WORD CDtvEngine::GetEventID()
{
	return m_ProgManager.GetEventID(m_wCurService);
}


const int CDtvEngine::GetEventName(LPTSTR pszName, int MaxLength, bool fNext)
{
	return m_ProgManager.GetEventName(m_wCurService,pszName,MaxLength,fNext);
}


const bool CDtvEngine::SetChannel(const BYTE byTuningSpace, const WORD wChannel)
{
	// `lύX
	m_SpecServiceID = SID_INVALID;
	if (!m_BonSrcDecoder.SetChannel((DWORD)byTuningSpace, (DWORD)wChannel)) {
		SetError(m_BonSrcDecoder.GetLastErrorException());
		return false;
	}
	ResetStatus();
	return true;
}


const bool CDtvEngine::SetService(const WORD wService)
{
	CBlockLock Lock(&m_EngineLock);

	// T[rXύX(wService==0xFFFFȂPAT擪T[rX)

	if (wService == 0xFFFF || wService < m_ProgManager.GetServiceNum()) {
		WORD wServiceID = 0xFFFF;

		if (wService == 0xFFFF) {
			m_wCurService = 0;
		} else {
			m_wCurService = wService;
		}
		// 擪PMT܂Ŏsɂ
		if (!m_ProgManager.GetServiceID(&wServiceID, wService))
			return false;

		m_CurServiceID = wServiceID;

		TRACE(TEXT("------- Service Select -------\n"));
		TRACE(TEXT("%d : ServiceID = %04X(%d)\n"), m_wCurService, wServiceID, wServiceID);

		if (m_bDescrambleCurServiceOnly)
			SetDescrambleService(wServiceID);

		if (m_bWriteCurServiceOnly) {
			BYTE StreamType;

			if (m_b1SegService
					&& (!m_ProgManager.GetVideoStreamType(&StreamType, m_wCurService)
						|| StreamType != 0x1B)) {
				// ZOT[rXPMT܂ŉۑȂ悤ɂ
				SetWriteService(0xFFFF, 0);
			} else {
				SetWriteService(wServiceID, m_WriteStream);
			}
		}

		if (m_bSendCurServiceOnly)
			SetNetworkService(wServiceID, m_SendStream);

		return true;
	}

	return false;
}


const WORD CDtvEngine::GetService(void) const
{
	// T[rX擾
	return m_wCurService;
}


const bool CDtvEngine::GetServiceID(WORD *pServiceID)
{
	// T[rXID擾
	return m_ProgManager.GetServiceID(pServiceID, m_wCurService);
}


const bool CDtvEngine::SetServiceByID(const WORD ServiceID)
{
	WORD Index;

	m_SpecServiceID = ServiceID;
	Index = m_ProgManager.GetServiceIndexByID(ServiceID);
	if (Index != 0xFFFF)
		SetService(Index);
	return true;
}


const bool CDtvEngine::Set1SegService(bool b1Seg)
{
	if (m_b1SegService != b1Seg) {
		m_b1SegService = b1Seg;
		if (b1Seg) {
			WORD NumServices = m_ProgManager.GetServiceNum();

			for (WORD i = 0 ; i < NumServices ; i++) {
				BYTE StreamType;

				if (m_ProgManager.GetVideoStreamType(&StreamType, i)
						&& StreamType == 0x1B) {
					SetService(i);
					break;
				}
			}
		}
	}
	return true;
}


const unsigned __int64 CDtvEngine::GetPcrTimeStamp() const
{
	// PCR^CX^v擾
	return m_u64CurPcrTimeStamp;
}


const DWORD CDtvEngine::SendDtvEngineEvent(const DWORD dwEventID, PVOID pParam)
{
	// CxgnhɃCxg𑗐M
	if(m_pDtvEngineHandler){
		return m_pDtvEngineHandler->OnDtvEngineEvent(this, dwEventID, pParam);
		}

	return 0UL;
}


const DWORD CDtvEngine::OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam)
{
	// fR[_̃Cxg󂯎(b)
	if (pDecoder == &m_ProgManager) {
		// vO}l[W̃Cxg
		WORD wTransportStream = m_ProgManager.GetTransportStreamID();
		switch (dwEventID) {
		case CProgManager::EID_SERVICE_LIST_UPDATED :
			// T[rX̍\ω
			if (m_wCurTransportStream != wTransportStream) {
				// Xg[IDςĂȂ珉
				TRACE(TEXT("Stream Change!! %04X\n"), wTransportStream);
				// ̎_ł܂T[rXSĂȂƂ̂ŁAۗ
				WORD Service = 0xFFFF;
				if (m_b1SegService) {
					WORD NumServices = m_ProgManager.GetServiceNum();

					for (WORD i = 0 ; i < NumServices ; i++) {
						BYTE StreamType;

						if (m_ProgManager.GetVideoStreamType(&StreamType, i)
								&& StreamType == 0x1B) {
							Service = i;
							break;
						}
					}
				} else if (m_SpecServiceID != SID_INVALID) {
					Service = m_ProgManager.GetServiceIndexByID(m_SpecServiceID);
				}
				if (SetService(Service)) {
					m_wCurTransportStream = wTransportStream;
					SendDtvEngineEvent(EID_SERVICE_LIST_UPDATED, &m_ProgManager);
				}
			} else {
				// Xg[ID͓A\ESPIDς\
				WORD Service = m_wCurService;
				if (m_b1SegService) {
					WORD NumServices = m_ProgManager.GetServiceNum();

					for (WORD i = 0 ; i < NumServices ; i++) {
						BYTE StreamType;

						if (m_ProgManager.GetVideoStreamType(&StreamType, i)
								&& StreamType == 0x1B) {
							Service = i;
							break;
						}
					}
				} else if (m_SpecServiceID != SID_INVALID) {
					Service = m_ProgManager.GetServiceIndexByID(m_SpecServiceID);
				} else if (m_CurServiceID != SID_INVALID) {
					Service = m_ProgManager.GetServiceIndexByID(m_CurServiceID);
				}
				SetService(Service);
			}
			return 0UL;

		case CProgManager::EID_SERVICE_INFO_UPDATED :
			// T[rXXVꂽ
			SendDtvEngineEvent(EID_SERVICE_INFO_UPDATED, &m_ProgManager);
			return 0UL;

		case CProgManager::EID_PCR_TIMESTAMP_UPDATED :
			// ^CX^vXVꂽ
			if (m_wCurService!=0xFFFF) {
				m_ProgManager.GetPcrTimeStamp(&m_u64CurPcrTimeStamp, m_wCurService);
			}
			SendDtvEngineEvent(EID_PCR_TIMESTAMP_UPDATED, static_cast<PVOID>(&m_ProgManager));
			return 0UL;
		}
	} else if (pDecoder == &m_FileWriter) {
		switch (dwEventID) {
		case CFileWriter::EID_WRITE_ERROR:
			// ݃G[
			SendDtvEngineEvent(EID_FILE_WRITE_ERROR, pDecoder);
			return 0UL;
		}
	}

	return 0UL;
}


bool CDtvEngine::CheckBuildComplete() const
{
	return m_bBuiled && IsSrcFilterOpen()
		&& (!m_bDescramble || m_TsDescrambler.IsBcasCardOpen());
}


bool CDtvEngine::OpenBcasCard(CCardReader::ReaderType CardReaderType)
{
	// B-CASJ[hJ
	if (CardReaderType!=CCardReader::READER_NONE) {
		Trace(TEXT("B-CASJ[hJĂ܂..."));
		if (!m_TsDescrambler.OpenBcasCard(CardReaderType)) {
			SetError(0,TEXT("B-CASJ[h̏Ɏs܂B"),
					 TEXT("J[h[_ڑĂ邩AݒŗLȃJ[h[_IĂ邩mFĂB"));
			m_bBuildComplete=false;
			return false;
		}
	} else if (m_TsDescrambler.IsBcasCardOpen()) {
		m_TsDescrambler.CloseBcasCard();
	}
	m_bBuildComplete=CheckBuildComplete();
	/*
	if (m_bBuildComplete)
		ResetEngine();
	*/
	return true;
}


bool CDtvEngine::SetDescramble(bool bDescramble)
{
	if (!m_bBuiled) {
		SetError(0,TEXT("G[ : DtvEngine\zĂ܂B"));
		return false;
	}

	if (m_bDescramble != bDescramble) {
		m_TsDescrambler.EnableDescramble(bDescramble);
		m_bDescramble = bDescramble;
		m_bBuildComplete = CheckBuildComplete();
	}
	return true;
}


bool CDtvEngine::SetDescrambleService(WORD ServiceID)
{
	return m_TsDescrambler.SetTargetServiceID(ServiceID);
}


bool CDtvEngine::SetDescrambleCurServiceOnly(bool bOnly)
{
	if (m_bDescrambleCurServiceOnly != bOnly) {
		WORD ServiceID = 0;

		m_bDescrambleCurServiceOnly = bOnly;
		if (bOnly)
			m_ProgManager.GetServiceID(&ServiceID, m_wCurService);
		SetDescrambleService(ServiceID);
	}
	return true;
}


bool CDtvEngine::SetWriteService(WORD ServiceID, DWORD Stream)
{
	return m_FileTsSelector.SetTargetServiceID(ServiceID, Stream);
}


bool CDtvEngine::SetWriteCurServiceOnly(bool bOnly, DWORD Stream)
{
	if (m_bWriteCurServiceOnly != bOnly || m_WriteStream != Stream) {
		m_bWriteCurServiceOnly = bOnly;
		m_WriteStream = Stream;
		if (bOnly) {
			WORD ServiceID = 0;

			m_ProgManager.GetServiceID(&ServiceID, m_wCurService);
			SetWriteService(ServiceID, Stream);
		} else {
			SetWriteService(0, Stream);
		}
	}
	return true;
}


bool CDtvEngine::StartNetworkSend(const CTsNetworkSender::AddressInfo *pAddressList, DWORD Length)
{
	StopNetworkSend();
	if (!m_TsNetworkSender.Open(pAddressList, Length))
		return false;

	return true;
}


bool CDtvEngine::StopNetworkSend()
{
	return m_TsNetworkSender.Close();
}


bool CDtvEngine::SetNetworkService(WORD ServiceID, DWORD Stream)
{
	return m_NetworkTsSelector.SetTargetServiceID(ServiceID, Stream);
}


bool CDtvEngine::SetSendCurServiceOnly(bool bOnly, DWORD Stream)
{
	if (m_bSendCurServiceOnly != bOnly || m_SendStream != Stream) {
		m_bSendCurServiceOnly = bOnly;
		m_SendStream = Stream;
		if (bOnly) {
			WORD ServiceID = 0;

			m_ProgManager.GetServiceID(&ServiceID, m_wCurService);
			SetNetworkService(ServiceID, Stream);
		} else {
			SetNetworkService(0, Stream);
		}
	}
	return true;
}


CEpgDataInfo *CDtvEngine::GetEpgDataInfo(WORD ServiceID, bool bNext)
{
	return m_TsPacketParser.GetEpgDataInfo(ServiceID, bNext);
}


void CDtvEngine::ResetStatus()
{
	m_wCurTransportStream = 0;
	m_CurServiceID = SID_INVALID;
}


//////////////////////////////////////////////////////////////////////
// CDtvEngineHandler \z/
//////////////////////////////////////////////////////////////////////

const DWORD CDtvEngineHandler::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam)
{
	// ftHg̏
	return 0UL;
}
