// DtvEngine.h: CDtvEngine NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "BonBaseClass.h"
#include "BonSrcDecoder.h"
#include "TsPacketParser.h"
#include "TsAnalyzer.h"
#include "TsDescrambler.h"
#include "ProgManager.h"
#include "MediaViewer.h"
#include "MediaTee.h"
#include "FileWriter.h"
#include "FileReader.h"
#include "MediaBuffer.h"
#include "MediaGrabber.h"
#include "TsSelector.h"

// ̕ӂ͑S̎bł


//////////////////////////////////////////////////////////////////////
// fW^TVGWNX
//////////////////////////////////////////////////////////////////////

class CDtvEngineHandler;

class CDtvEngine : protected CMediaDecoder::IEventHandler, public CBonBaseClass
{
public:
	enum EVENTID
	{
		EID_SERVICE_LIST_UPDATED,	// T[rXXgXV
		EID_SERVICE_INFO_UPDATED,	// T[rXXV
		EID_PCR_TIMESTAMP_UPDATED,	// PCR^CX^vXV(Ȃp)
		EID_FILE_WRITE_ERROR
	};

	CDtvEngine(void);
	~CDtvEngine(void);

	const bool BuildEngine(CDtvEngineHandler *pDtvEngineHandler,
						   bool bDescramble = true, bool bBuffering = false);
	const bool IsEngineBuild() const { return m_bBuiled; };
	const bool IsBuildComplete() const { return m_bBuildComplete; }
	const bool CloseEngine(void);
	const bool ResetEngine(void);

	const bool OpenSrcFilter_BonDriver(HMODULE hBonDriverDll);
	const bool OpenSrcFilter_File(LPCTSTR lpszFileName);
	const bool ReleaseSrcFilter();
	const bool IsSrcFilterOpen() const;

	const bool EnablePreview(const bool bEnable = true);
	const bool SetViewSize(const int x,const int y);
	const bool SetVolume(const float fVolume);
	const bool GetVideoSize(WORD *pwWidth,WORD *pwHeight);
	const bool GetVideoAspectRatio(BYTE *pbyAspectRateX,BYTE *pbyAspectRateY);
	const BYTE GetAudioChannelNum();
	const int GetAudioStreamNum(const WORD wService = 0);
	const bool SetAudioStream(int StreamIndex);
	const int GetAudioStream() const;
	const BYTE GetAudioComponentType();
	const bool SetStereoMode(int iMode);
	const WORD GetEventID();
	const int GetEventName(LPTSTR pszName, int MaxLength, bool fNext = false);
	const bool GetVideoDecoderName(LPWSTR lpName,int iBufLen);
	const bool DisplayVideoDecoderProperty(HWND hWndParent);

	const bool SetChannel(const BYTE byTuningSpace, const WORD wChannel);
	const bool SetService(const WORD wService);
	const WORD GetService(void) const;
	const bool GetServiceID(WORD *pServiceID);
	const bool SetServiceByID(const WORD ServiceID);
	const unsigned __int64 GetPcrTimeStamp() const;

	/*
	const bool PlayFile(LPCTSTR lpszFileName);
	void StopFile(void);
	*/

	bool BuildMediaViewer(HWND hwndHost,HWND hwndMessage,
		CVideoRenderer::RendererType VideoRenderer=CVideoRenderer::RENDERER_DEFAULT,
		LPCWSTR pszMpeg2Decoder=NULL,LPCWSTR pszAudioDevice=NULL);
	bool RebuildMediaViewer(HWND hwndHost,HWND hwndMessage,
		CVideoRenderer::RendererType VideoRenderer=CVideoRenderer::RENDERER_DEFAULT,
		LPCWSTR pszMpeg2Decoder=NULL,LPCWSTR pszAudioDevice=NULL);
	bool OpenBcasCard(CCardReader::ReaderType CardReaderType);
	bool SetDescramble(bool bDescramble);
	bool ResetBuffer();
	bool GetOriginalVideoSize(WORD *pWidth,WORD *pHeight);
	bool SetDescrambleService(WORD Service);
	bool SetDescrambleCurServiceOnly(bool bOnly);
	bool GetDescrambleCurServiceOnly() const { return m_bDescrambleCurServiceOnly; }
	bool SetWriteService(WORD Service,DWORD Stream=CTsSelector::STREAM_ALL);
	bool SetWriteCurServiceOnly(bool bOnly,DWORD Stream=CTsSelector::STREAM_ALL);
	bool GetWriteCurServiceOnly() const { return m_bWriteCurServiceOnly; }
	CEpgDataInfo *GetEpgDataInfo(WORD ServiceID, bool bNext=false);
// CBonBaseClass
	void SetTracer(CTracer *pTracer);

//protected:
	// CMediaDecoder hfBAfR[_NX
	CBonSrcDecoder m_BonSrcDecoder;			// TS\[X`[i[(HALׂ)
	CTsPacketParser m_TsPacketParser;		// TSpPb^CU[
	CTsAnalyzer m_TsAnalyzer;
	CTsDescrambler m_TsDescrambler;			// TSfXNu[
	CProgManager m_ProgManager;				// TSvO}l[W[
	CMediaViewer m_MediaViewer;				// fBAr[A[
	CMediaTee m_MediaTee;					// fBAeB[
	CFileWriter m_FileWriter;				// t@CC^[
	CFileReader m_FileReader;				// t@C[_[
	CMediaBuffer m_MediaBuffer;
	CMediaGrabber m_MediaGrabber;
	CTsSelector m_TsSelector;

protected:
	const DWORD SendDtvEngineEvent(const DWORD dwEventID, PVOID pParam = NULL);
	virtual const DWORD OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam);
	bool CheckBuildComplete() const;

	CCriticalLock m_EngineLock;
	CDtvEngineHandler *m_pDtvEngineHandler;
	WORD m_wCurTransportStream;
	WORD m_wCurService;
	WORD m_SpecServiceID;
	int m_CurAudioStream;
	unsigned __int64 m_u64CurPcrTimeStamp;

	bool m_bBuiled;
	bool m_bBuildComplete;
	bool m_bIsFileMode;
	bool m_bDescramble;
	bool m_bBuffering;

	bool m_bDescrambleCurServiceOnly;
	bool m_bWriteCurServiceOnly;

	void ResetStatus();
};


//////////////////////////////////////////////////////////////////////
// fW^TVCxgnhC^tF[X
//////////////////////////////////////////////////////////////////////

// ͏z֐Ƃׂ
class CDtvEngineHandler
{
friend CDtvEngine;

protected:
	virtual const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);
};
