// DtvEngine.h: CDtvEngine NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "BonBaseClass.h"
#include "BonSrcDecoder.h"
#include "TsPacketParser.h"
#include "TsAnalyzer.h"
#include "TsDescrambler.h"
#include "ProgManager.h"
#include "MediaTee.h"
#include "FileWriter.h"
#include "MediaGrabber.h"
#include "TsSelector.h"
#include "TsNetworkSender.h"
#include "Exception.h"

// ̕ӂ͑S̎bł


//////////////////////////////////////////////////////////////////////
// fW^TVGWNX
//////////////////////////////////////////////////////////////////////

class CDtvEngineHandler;

class CDtvEngine : protected CMediaDecoder::IEventHandler, public CBonBaseClass
{
public:
	enum EVENTID
	{
		EID_SERVICE_LIST_UPDATED,	// T[rXXgXV
		EID_SERVICE_INFO_UPDATED,	// T[rXXV
		EID_PCR_TIMESTAMP_UPDATED,	// PCR^CX^vXV(Ȃp)
		EID_FILE_WRITE_ERROR
	};

	CDtvEngine(void);
	~CDtvEngine(void);

	const bool BuildEngine(CDtvEngineHandler *pDtvEngineHandler,bool bDescramble=true);
	const bool IsEngineBuild() const { return m_bBuiled; };
	const bool IsBuildComplete() const { return m_bBuildComplete; }
	const bool CloseEngine(void);
	const bool ResetEngine(void);

	const bool OpenSrcFilter_BonDriver(HMODULE hBonDriverDll);
	const bool ReleaseSrcFilter();
	const bool IsSrcFilterOpen() const;

	const BYTE GetAudioComponentType();
	const WORD GetEventID();
	const int GetEventName(LPTSTR pszName, int MaxLength, bool fNext = false);

	const bool SetChannel(const BYTE byTuningSpace, const WORD wChannel);
	const bool SetService(const WORD wService);
	const WORD GetService(void) const;
	const bool GetServiceID(WORD *pServiceID);
	const bool SetServiceByID(const WORD ServiceID);
	const bool Set1SegService(bool b1Seg);
	const unsigned __int64 GetPcrTimeStamp() const;

	bool OpenBcasCard(CCardReader::ReaderType CardReaderType);
	bool SetDescramble(bool bDescramble);
	bool ResetBuffer();
	bool SetDescrambleService(WORD ServiceID);
	bool SetDescrambleCurServiceOnly(bool bOnly);
	bool GetDescrambleCurServiceOnly() const { return m_bDescrambleCurServiceOnly; }
	bool SetWriteService(WORD ServiceID, DWORD Stream=CTsSelector::STREAM_ALL);
	bool SetWriteCurServiceOnly(bool bOnly, DWORD Stream=CTsSelector::STREAM_ALL);
	bool GetWriteCurServiceOnly() const { return m_bWriteCurServiceOnly; }
	bool StartNetworkSend(const CTsNetworkSender::AddressInfo *pAddressList, DWORD Length);
	bool StopNetworkSend();
	bool SetNetworkService(WORD ServiceID, DWORD Stream=CTsSelector::STREAM_ALL);
	bool SetSendCurServiceOnly(bool bOnly, DWORD Stream=CTsSelector::STREAM_ALL);
	bool GetSendCurServiceOnly() const { return m_bSendCurServiceOnly; }
	CEpgDataInfo *GetEpgDataInfo(WORD ServiceID, bool bNext=false);

//protected:
	// CMediaDecoder hfBAfR[_NX
	CBonSrcDecoder m_BonSrcDecoder;			// TS\[X`[i[(HALׂ)
	CTsPacketParser m_TsPacketParser;		// TSpPb^CU[
	CTsAnalyzer m_TsAnalyzer;
	CTsDescrambler m_TsDescrambler;			// TSfXNu[
	CProgManager m_ProgManager;				// TSvO}l[W[
	CMediaTee m_MediaTee;					// fBAeB[
	CFileWriter m_FileWriter;				// t@CC^[
	CMediaGrabber m_MediaGrabber;
	CMediaGrabber m_TvRockGrabber;
	CTsSelector m_FileTsSelector;
	CTsSelector m_NetworkTsSelector;
	CTsNetworkSender m_TsNetworkSender;

protected:
	const DWORD SendDtvEngineEvent(const DWORD dwEventID, PVOID pParam = NULL);
	virtual const DWORD OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam);
	bool CheckBuildComplete() const;

	CCriticalLock m_EngineLock;
	CDtvEngineHandler *m_pDtvEngineHandler;
	WORD m_wCurTransportStream;
	WORD m_wCurService;
	WORD m_CurServiceID;
	WORD m_SpecServiceID;
	bool m_b1SegService;
	unsigned __int64 m_u64CurPcrTimeStamp;

	bool m_bBuiled;
	bool m_bBuildComplete;
	bool m_bDescramble;

	bool m_bDescrambleCurServiceOnly;
	bool m_bWriteCurServiceOnly;
	DWORD m_WriteStream;
	bool m_bSendCurServiceOnly;
	DWORD m_SendStream;

	void ResetStatus();
};


//////////////////////////////////////////////////////////////////////
// fW^TVCxgnhC^tF[X
//////////////////////////////////////////////////////////////////////

// ͏z֐Ƃׂ
class CDtvEngineHandler
{
friend CDtvEngine;

protected:
	virtual const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);
};
