#ifndef UDP_OPTIONS_H
#define UDP_OPTIONS_H


#include "Options.h"
#include "Settings.h"
#include "TsNetworkSender.h"


class CUdpOptions : public COptions {
	TCHAR m_szViewProgramPath[MAX_PATH];
	TCHAR m_szViewProgramParameter[128];
	CTsNetworkSender::SocketType m_SocketType;
	TCHAR m_szAddress[64];
	unsigned int m_Port;
	HANDLE m_hPortMutex;
	unsigned int m_RealPort;
	bool m_fSendCurServiceOnly;
	bool m_fSendSubtitle;
	bool m_fSendDataCarrousel;
	static CUdpOptions *GetThis(HWND hDlg);
public:
	CUdpOptions();
	~CUdpOptions();
	bool Read(CSettings *pSettings);
	bool Write(CSettings *pSettings) const;
	bool ExecuteViewer() const;
	enum {
		PROTOCOL_DEFAULT=-1,
		PROTOCOL_UDP,
		PROTOCOL_TCP
	};
	bool StartNetworkSend(int Protocol=PROTOCOL_DEFAULT,unsigned int Port=0);
	bool StopNetworkSend();
	bool IsNetworkSending() const;
	int GetProtocol() const;
	unsigned int GetSendingPort() const { return m_RealPort; }
	static BOOL CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
};


#endif
